=== common/CMakeLists.txt ===
add_library(common STATIC daemon.cpp sampleFormat.cpp)
