=== debian/changelog ===
snapcast (0.15.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop add_ldflags.patch, fixed upstream.
  * Disable statically linking libgcc and libstdc++
    - Add disable_static_linking.patch
  * Enable all hardening compiler flags.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 28 Jul 2018 11:48:26 +0200
