=== debian/changelog ===
snapcast (0.18.0-1) unstable; urgency=medium

  * New upstream release.
    - Switch build-depends from libasio-dev to libboost1.71-dev.
    - Add libopus-dev to build-depends.
  * Switch from Makefile to cmake build system.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 26 Jan 2020 15:59:12 +0100
